diff --git a/oflog/include/dcmtk/oflog/helpers/fileinfo.h b/oflog/include/dcmtk/oflog/helpers/fileinfo.h
new file mode 100644
index 0000000..c9e0999
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/helpers/fileinfo.h
@@ -0,0 +1,62 @@
+// -*- C++ -*-
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#if ! defined (DCMTK_LOG4CPLUS_HELPERS_FILEINFO_H)
+#define DCMTK_LOG4CPLUS_HELPERS_FILEINFO_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/helpers/timehelp.h"
+#ifdef DCMTK_LOG4CPLUS_HAVE_SYS_TYPES_H
+#include <sys/types.h>
+#endif
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+//! FileInfo structure is OS independent abstraction of the
+//! <code>stat()</code> function.
+struct DCMTK_LOG4CPLUS_EXPORT FileInfo
+{
+    FileInfo() : mtime(), is_link(false), size(0) {}
+    helpers::Time mtime;
+    bool is_link;
+    off_t size;
+};
+
+
+//! OS independent abstraction of <code>stat()</code> function.
+DCMTK_LOG4CPLUS_EXPORT int getFileInfo (FileInfo * fi, tstring const & name);
+
+
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
+
+#endif // DCMTK_LOG4CPLUS_HELPERS_FILEINFO_H
diff --git a/oflog/include/dcmtk/oflog/helpers/lloguser.h b/oflog/include/dcmtk/oflog/helpers/lloguser.h
index 8db6146..7135911 100644
--- a/oflog/include/dcmtk/oflog/helpers/lloguser.h
+++ b/oflog/include/dcmtk/oflog/helpers/lloguser.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
-// File:    logloguser.h
+// File:    lloguser.h
 // Created: 6/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,11 +21,15 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_LOGLOG_USER
-#define DCMTK__LOG4CPLUS_HELPERS_LOGLOG_USER
+#ifndef DCMTK_LOG4CPLUS_HELPERS_LOGLOG_USER
+#define DCMTK_LOG4CPLUS_HELPERS_LOGLOG_USER
 
 #include "dcmtk/oflog/config.h"
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 
 namespace dcmtk {
 namespace log4cplus {
@@ -37,7 +42,8 @@ namespace log4cplus {
          * that uses the LogLog class should extend this class and retrieve
          * their reference to LogLog using the method provided.
          */
-        class DCMTK_LOG4CPLUS_EXPORT LogLogUser {
+        class DCMTK_LOG4CPLUS_EXPORT LogLogUser
+        {
         public:
           // ctor and dtor
             LogLogUser();
@@ -46,13 +52,9 @@ namespace log4cplus {
 
           // public methods
             LogLog& getLogLog() const;
-
+            
           // operators
             LogLogUser& operator=(const LogLogUser& rhs);
-
-        private:
-          // Data
-            void* loglogRef;
         };
 
     } // end namespace helpers
@@ -60,5 +62,5 @@ namespace log4cplus {
 } // end namespace dcmtk
 
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_LOGLOG_USER
+#endif // DCMTK_LOG4CPLUS_HELPERS_LOGLOG_USER
 
diff --git a/oflog/include/dcmtk/oflog/helpers/lockfile.h b/oflog/include/dcmtk/oflog/helpers/lockfile.h
new file mode 100644
index 0000000..1ae5b55
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/helpers/lockfile.h
@@ -0,0 +1,73 @@
+// -*- C++ -*-
+//
+//  Copyright (C) 2012, Vaclav Zeman. All rights reserved.
+//
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#if ! defined (DCMTK_LOG4CPLUS_HELPERS_LOCKFILE_H)
+#define DCMTK_LOG4CPLUS_HELPERS_LOCKFILE_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/tstring.h"
+#include "dcmtk/oflog/thread/syncprim.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace helpers {
+
+
+class DCMTK_LOG4CPLUS_EXPORT LockFile
+{
+public:
+    LockFile (tstring const & lock_file);
+    ~LockFile ();
+
+    void lock () const;
+    void unlock () const;
+
+private:
+    LockFile (LockFile&);
+    LockFile &operator= (const LockFile&);
+
+    void open (int) const;
+    void close () const;
+
+    struct Impl;
+
+    tstring lock_file_name;
+    Impl * data;
+};
+
+
+typedef log4cplus::thread::SyncGuard<LockFile> LockFileGuard;
+
+
+} } // namespace log4cplus { namespace helpers {
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_HELPERS_LOCKFILE_H
diff --git a/oflog/include/dcmtk/oflog/helpers/loglog.h b/oflog/include/dcmtk/oflog/helpers/loglog.h
index 68003a9..e9699f9 100644
--- a/oflog/include/dcmtk/oflog/helpers/loglog.h
+++ b/oflog/include/dcmtk/oflog/helpers/loglog.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    loglog.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,13 +21,18 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_LOGLOG
-#define DCMTK__LOG4CPLUS_HELPERS_LOGLOG
+#ifndef DCMTK_LOG4CPLUS_HELPERS_LOGLOG
+#define DCMTK_LOG4CPLUS_HELPERS_LOGLOG
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/tstring.h"
-#include "dcmtk/oflog/helpers/pointer.h"
-#include "dcmtk/oflog/helpers/threads.h"
+#include "dcmtk/oflog/streams.h"
+#include "dcmtk/oflog/thread/syncprim.h"
 
 
 namespace dcmtk {
@@ -47,14 +53,15 @@ namespace log4cplus {
          * the string "log4clus: ".
          */
         class DCMTK_LOG4CPLUS_EXPORT LogLog
-            : public virtual helpers::SharedObject
         {
         public:
-          // Static methods
+            //! Return type of getLogLog().
+            typedef LogLog * Ptr;
+
             /**
              * Returns a reference to the <code>LogLog</code> singleton.
              */
-            static helpers::SharedObjectPtr<LogLog> getLogLog();
+            static Ptr getLogLog();
 
 
             /**
@@ -64,7 +71,7 @@ namespace log4cplus {
 
             /**
              * In quite mode no LogLog generates strictly no output, not even
-             * for errors.
+             * for errors. 
              *
              * @param quietMode A true for not
              */
@@ -74,42 +81,66 @@ namespace log4cplus {
              * This method is used to output log4cplus internal debug
              * statements. Output goes to <code>STD_NAMESPACE cout</code>.
              */
-            void debug(const tstring& msg);
+            void debug(const log4cplus::tstring& msg) const;
+            void debug(tchar const * msg) const;
 
             /**
              * This method is used to output log4cplus internal error
-             * statements. There is no way to disable error statements.
-             * Output goes to <code>STD_NAMESPACE cerr</code>.
+             * statements. There is no way to disable error
+             * statements.  Output goes to
+             * <code>STD_NAMESPACE cerr</code>. Optionally, this method can
+             * throw STD_NAMESPACE runtime_error exception too.
              */
-            void error(const tstring& msg);
+            void error(const log4cplus::tstring& msg, bool throw_flag = false) const;
+            void error(tchar const * msg, bool throw_flag = false) const;
 
             /**
              * This method is used to output log4cplus internal warning
              * statements. There is no way to disable warning statements.
              * Output goes to <code>STD_NAMESPACE cerr</code>.
              */
-            void warn(const tstring& msg);
+            void warn(const log4cplus::tstring& msg) const;
+            void warn(tchar const * msg) const;
 
-          // Dtor
+            // Public ctor and dtor to be used only by internal::DefaultContext.
+            LogLog();
             virtual ~LogLog();
 
-          // Data
-            DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE mutex;
-
         private:
-          // Data
-            bool debugEnabled;
-            bool quietMode;
-
-          // Ctors
-            LogLog();
-            LogLog(const LogLog&);
+            enum TriState
+            {
+                TriUndef = -1,
+                TriFalse,
+                TriTrue
+            };
+
+            DCMTK_LOG4CPLUS_PRIVATE
+            void logging_worker (tostream & os,
+                bool (LogLog:: * cond) () const, tchar const *,
+                tchar const *, bool throw_flag = false) const;
+
+            DCMTK_LOG4CPLUS_PRIVATE static void set_tristate_from_env (TriState *,
+                tchar const * envvar);
+
+            DCMTK_LOG4CPLUS_PRIVATE bool get_quiet_mode () const;
+            DCMTK_LOG4CPLUS_PRIVATE bool get_not_quiet_mode () const;
+            DCMTK_LOG4CPLUS_PRIVATE bool get_debug_mode () const;
+
+            // Data
+            mutable TriState debugEnabled;
+            mutable TriState quietMode;
+            thread::Mutex mutex;
+
+            DCMTK_LOG4CPLUS_PRIVATE LogLog(const LogLog&);
+            DCMTK_LOG4CPLUS_PRIVATE LogLog & operator = (LogLog const &);
         };
 
+        DCMTK_LOG4CPLUS_EXPORT LogLog & getLogLog ();
+
     } // end namespace helpers
 } // end namespace log4cplus
 } // end namespace dcmtk
 
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_LOGLOG
+#endif // DCMTK_LOG4CPLUS_HELPERS_LOGLOG
 
diff --git a/oflog/include/dcmtk/oflog/helpers/pointer.h b/oflog/include/dcmtk/oflog/helpers/pointer.h
index e6081cd..4f93624 100644
--- a/oflog/include/dcmtk/oflog/helpers/pointer.h
+++ b/oflog/include/dcmtk/oflog/helpers/pointer.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    pointer.h
 // Created: 6/2001
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2001-2009 Tad E. Smith
+// Copyright 2001-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -25,18 +26,23 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_POINTERS_HEADER_
-#define DCMTK__LOG4CPLUS_HELPERS_POINTERS_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HELPERS_POINTERS_HEADER_
+#define DCMTK_LOG4CPLUS_HELPERS_POINTERS_HEADER_
 
 #include "dcmtk/oflog/config.h"
-//#include <memory>
-//#include <stdexcept>
-//#include <string>
-//#include <algorithm>
-//#include <cassert>
 
-#define INCLUDE_CASSERT
-#include "dcmtk/ofstd/ofstdinc.h"
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#include "dcmtk/oflog/thread/syncprim.h"
+#include <algorithm>
+#include <cassert>
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED) \
+    && defined (DCMTK_LOG4CPLUS_HAVE_CXX11_ATOMICS)
+#include <atomic>
+#endif
+
 
 namespace dcmtk {
 namespace log4cplus {
@@ -55,12 +61,12 @@ namespace log4cplus {
         protected:
           // Ctor
             SharedObject()
-                : access_mutex(DCMTK_LOG4CPLUS_MUTEX_CREATE)
+                : access_mutex()
                 , count(0)
             { }
 
             SharedObject(const SharedObject&)
-                : access_mutex(DCMTK_LOG4CPLUS_MUTEX_CREATE)
+                : access_mutex()
                 , count(0)
             { }
 
@@ -71,10 +77,19 @@ namespace log4cplus {
             SharedObject& operator=(const SharedObject&) { return *this; }
 
         public:
-            DCMTK_LOG4CPLUS_MUTEX_PTR_DECLARE access_mutex;
+            thread::Mutex access_mutex;
 
         private:
-            mutable int count;
+#if defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+            typedef unsigned count_type;
+#elif defined (DCMTK_LOG4CPLUS_HAVE_CXX11_ATOMICS)
+            typedef STD_NAMESPACE atomic<unsigned> count_type;
+#elif defined (_WIN32) || defined (__CYGWIN__)
+            typedef long count_type;
+#else
+            typedef unsigned count_type;
+#endif
+            mutable count_type count;
         };
 
 
@@ -99,6 +114,20 @@ namespace log4cplus {
                 addref ();
             }
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_RVALUE_REFS)
+            SharedObjectPtr(SharedObjectPtr && rhs)
+                : pointee (STD_NAMESPACE move (rhs.pointee))
+            {
+                rhs.pointee = 0;
+            }
+
+            SharedObjectPtr & operator = (SharedObjectPtr && rhs)
+            {
+                rhs.swap (*this);
+                return *this;
+            }
+#endif
+
             // Dtor
             ~SharedObjectPtr()
             {
@@ -133,7 +162,6 @@ namespace log4cplus {
                 T* tmp = pointee;
                 pointee = other.pointee;
                 other.pointee = tmp;
-                //STD_NAMESPACE swap (pointee, other.pointee);
             }
 
             typedef T * (SharedObjectPtr:: * unspec_bool_type) () const;
@@ -161,7 +189,7 @@ namespace log4cplus {
 
     } // end namespace helpers
 } // end namespace log4cplus
-} // namespace dcmtk
+} // end namespace dcmtk
 
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_POINTERS_HEADER_
+#endif // DCMTK_LOG4CPLUS_HELPERS_POINTERS_HEADER_
diff --git a/oflog/include/dcmtk/oflog/helpers/property.h b/oflog/include/dcmtk/oflog/helpers/property.h
index bbced51..3e42c4c 100644
--- a/oflog/include/dcmtk/oflog/helpers/property.h
+++ b/oflog/include/dcmtk/oflog/helpers/property.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    property.h
 // Created: 2/2002
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2002-2009 Tad E. Smith
+// Copyright 2002-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -24,16 +25,15 @@
 #define DCMTK_LOG4CPLUS_HELPERS_PROPERTY_HEADER_
 
 #include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 #include "dcmtk/oflog/streams.h"
 #include "dcmtk/oflog/tstring.h"
-//#include <map>
 #include "dcmtk/ofstd/ofmap.h"
-//#include <vector>
-#include "dcmtk/ofstd/oflist.h"
-
-#if (defined(__MWERKS__) && defined(__MACOS__))
-using STD_NAMESPACE size_t;
-#endif
+#include "dcmtk/ofstd/ofvector.h"
 
 
 namespace dcmtk {
@@ -42,9 +42,30 @@ namespace log4cplus {
 
         class DCMTK_LOG4CPLUS_EXPORT Properties {
         public:
+            enum PFlags
+            {
+                // These encoding related options occupy 2 bits of the flags
+                // and are mutually exclusive. These flags are synchronized
+                // with PCFlags in PropertyConfigurator.
+
+                fEncodingShift      = 3
+                , fEncodingMask     = 0x3
+                , fUnspecEncoding   = (0 << fEncodingShift)
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF8_FACET) && defined (UNICODE)
+                , fUTF8             = (1 << fEncodingShift)
+#endif
+#if (defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF16_FACET) || defined (_WIN32)) \
+    && defined (UNICODE)
+                , fUTF16            = (2 << fEncodingShift)
+#endif
+#if defined (DCMTK_LOG4CPLUS_HAVE_CODECVT_UTF32_FACET) && defined (UNICODE)
+                , fUTF32            = (3 << fEncodingShift)
+#endif
+            };
+
             Properties();
-            explicit Properties(tistream& input);
-            explicit Properties(const tstring& inputFile);
+            explicit Properties(log4cplus::tistream& input);
+            explicit Properties(const log4cplus::tstring& inputFile, unsigned flags = 0);
             virtual ~Properties();
 
           // constants
@@ -54,68 +75,82 @@ namespace log4cplus {
             /**
              * Tests to see if <code>key</code> can be found in this map.
              */
-            bool exists(const tstring& key) const {
-                return data.find(key) != data.end();
-            }
-
+            bool exists(const log4cplus::tstring& key) const;
+            bool exists(tchar const * key) const;
 
             /**
              * Returns the number of entries in this map.
              */
-            size_t size() const {
+            size_t size() const
+            {
                 return data.size();
             }
 
             /**
              * Searches for the property with the specified key in this property
              * list. If the key is not found in this property list, the default
-             * property list, and its defaults, recursively, are then checked.
+             * property list, and its defaults, recursively, are then checked. 
              * The method returns <code>null</code> if the property is not found.
              */
-            tstring getProperty(const tstring& key) const;
+            log4cplus::tstring const & getProperty(const log4cplus::tstring& key) const;
+            log4cplus::tstring const & getProperty(tchar const * key) const;
 
             /**
              * Searches for the property with the specified key in this property
              * list. If the key is not found in this property list, the default
-             * property list, and its defaults, recursively, are then checked.
-             * The method returns the default value argument if the property is
+             * property list, and its defaults, recursively, are then checked. 
+             * The method returns the default value argument if the property is 
              * not found.
              */
-            tstring getProperty(const tstring& key,
-                                const tstring& defaultVal) const;
+            log4cplus::tstring getProperty(const log4cplus::tstring& key,
+                                           const log4cplus::tstring& defaultVal) const;
 
             /**
              * Returns all the keys in this property list.
              */
-            OFList<tstring> propertyNames() const;
+            OFVector<log4cplus::tstring> propertyNames() const;
 
             /**
              * Inserts <code>value</code> into this map indexed by <code>key</code>.
              */
-            void setProperty(const tstring& key, const tstring& value);
+            void setProperty(const log4cplus::tstring& key, const log4cplus::tstring& value);
 
             /**
              * Removed the property index by <code>key</code> from this map.
              */
-            bool removeProperty(const tstring& key);
+            bool removeProperty(const log4cplus::tstring& key);
 
             /**
              * Returns a subset of the "properties" whose keys start with
              * "prefix".  The returned "properties" have "prefix" trimmed from
              * their keys.
              */
-            Properties getPropertySubset(const tstring& prefix) const;
+            Properties getPropertySubset(const log4cplus::tstring& prefix) const;
+
+            bool getInt (int & val, log4cplus::tstring const & key) const;
+            bool getUInt (unsigned & val, log4cplus::tstring const & key) const;
+            bool getLong (long & val, log4cplus::tstring const & key) const;
+            bool getULong (unsigned long & val, log4cplus::tstring const & key) const;
+            bool getBool (bool & val, log4cplus::tstring const & key) const;
 
         protected:
           // Types
-//            LOG4CPLUS_EXPIMP_TEMPLATE template class DCMTK_LOG4CPLUS_EXPORT STD_NAMESPACE map<tstring, tstring>;
-            typedef OFMap<tstring, tstring> StringMap;
+            typedef OFMap<log4cplus::tstring, log4cplus::tstring> StringMap;
 
           // Methods
-            void init(tistream& input);
+            void init(log4cplus::tistream& input);
 
           // Data
             StringMap data;
+
+        private:
+            template <typename StringType>
+            log4cplus::tstring const & get_property_worker (
+                StringType const & key) const;
+
+            template <typename ValType>
+            bool get_type_val_worker (ValType & val,
+                log4cplus::tstring const & key) const;
         };
     } // end namespace helpers
 
diff --git a/oflog/include/dcmtk/oflog/helpers/queue.h b/oflog/include/dcmtk/oflog/helpers/queue.h
new file mode 100644
index 0000000..1ec0201
--- /dev/null
+++ b/oflog/include/dcmtk/oflog/helpers/queue.h
@@ -0,0 +1,160 @@
+// -*- C++ -*-
+//  Copyright (C) 2009-2010, Vaclav Haisman. All rights reserved.
+//  
+//  Redistribution and use in source and binary forms, with or without modifica-
+//  tion, are permitted provided that the following conditions are met:
+//  
+//  1. Redistributions of  source code must  retain the above copyright  notice,
+//     this list of conditions and the following disclaimer.
+//  
+//  2. Redistributions in binary form must reproduce the above copyright notice,
+//     this list of conditions and the following disclaimer in the documentation
+//     and/or other materials provided with the distribution.
+//  
+//  THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES,
+//  INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
+//  FITNESS  FOR A PARTICULAR  PURPOSE ARE  DISCLAIMED.  IN NO  EVENT SHALL  THE
+//  APACHE SOFTWARE  FOUNDATION  OR ITS CONTRIBUTORS  BE LIABLE FOR  ANY DIRECT,
+//  INDIRECT, INCIDENTAL, SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL  DAMAGES (INCLU-
+//  DING, BUT NOT LIMITED TO, PROCUREMENT  OF SUBSTITUTE GOODS OR SERVICES; LOSS
+//  OF USE, DATA, OR  PROFITS; OR BUSINESS  INTERRUPTION)  HOWEVER CAUSED AND ON
+//  ANY  THEORY OF LIABILITY,  WHETHER  IN CONTRACT,  STRICT LIABILITY,  OR TORT
+//  (INCLUDING  NEGLIGENCE OR  OTHERWISE) ARISING IN  ANY WAY OUT OF THE  USE OF
+//  THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+#ifndef DCMTK_LOG4CPLUS_HELPERS_QUEUE_H
+#define DCMTK_LOG4CPLUS_HELPERS_QUEUE_H
+
+#include "dcmtk/oflog/config.h"
+
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
+#if ! defined (DCMTK_LOG4CPLUS_SINGLE_THREADED)
+
+#include "dcmtk/oflog/spi/logevent.h"
+#include "dcmtk/oflog/thread/threads.h"
+#include "dcmtk/oflog/thread/syncprim.h"
+#include "dcmtk/ofstd/ofvector.h"
+
+
+namespace dcmtk {
+namespace log4cplus { namespace thread {
+
+
+//! Single consumer, multiple producers queue.
+class DCMTK_LOG4CPLUS_EXPORT Queue
+    : public virtual helpers::SharedObject
+{
+public:
+    //! Type of the state flags field.
+    typedef unsigned flags_type;
+
+    //! Queue storage type.
+    typedef OFVector<spi::InternalLoggingEvent> queue_storage_type;
+
+    Queue (unsigned len = 100);
+    virtual ~Queue ();
+
+    // Producers' methods.
+
+    //! Puts event <code>ev</code> into queue, sets QUEUE flag and
+    //! sets internal event object into signaled state. If the EXIT
+    //! flags is already set upon entering the function, nothing is
+    //! inserted into the queue. The function can block on internal
+    //! semaphore if the queue has reached maximal allowed
+    //! length. Calling thread is unblocked either by consumer thread
+    //! removing item from queue or by any other thread calling
+    //! signal_exit().
+    //!
+    //! \param ev spi::InternalLoggingEvent to be put into the queue.
+    //! \return Flags.
+    flags_type put_event (spi::InternalLoggingEvent const & ev);
+
+    //! Sets EXIT flag and DRAIN flag and sets internal event object
+    //! into signaled state.
+    //! \param drain If true, DRAIN flag will be set, otherwise unset.
+    //! \return Flags, ERROR_BIT can be set upon error.
+    flags_type signal_exit (bool drain = true);
+
+    // Consumer's methods.
+
+    //! The get_events() function is used by queue's consumer. It
+    //! fills <code>buf</code> argument and sets EVENT flag in return
+    //! value. If EXIT flag is already set in flags member upon
+    //! entering the function then depending on DRAIN flag it either
+    //! fills <code>buf</code> argument or does not fill the argument,
+    //! if the queue is non-empty. The function blocks by waiting for
+    //! internal event object to be signaled if the queue is empty,
+    //! unless EXIT flag is set. The calling thread is unblocked when
+    //! items are added into the queue or when exit is signaled using
+    //! the signal_exit() function.
+    //!
+    //!
+    //! Upon error, return value has one of the error flags set.
+    //!
+    //! \param buf Pointer to storage of spi::InternalLoggingEvent
+    //! instances to be filled from queue.
+    //! \return Flags.
+    flags_type get_events (queue_storage_type * buf);
+
+    //! Possible state flags.
+    enum Flags
+    {
+        //! EVENT flag is set in return value of get_event() call if
+        //! the <code>ev</code> argument is filled with event from the queue.
+        EVENT       = 0x0001,
+
+        //! QUEUE flag is set by producers when they put item into the
+        //! queue.
+        QUEUE       = 0x0002,
+
+        //! EXIT flag is set by signal_exit() call, signaling that the
+        //! queue worker thread should end itself.
+        EXIT        = 0x0004,
+
+        //! When DRAIN flag is set together with EXIT flag, the queue
+        //! worker thread will first drain the queue before exiting.
+        DRAIN       = 0x0008,
+
+        //! ERROR_BIT signals error.
+        ERROR_BIT   = 0x0010,
+
+        //! ERROR_AFTER signals error that has occured after queue has
+        //! already been touched.
+        ERROR_AFTER = 0x0020
+    };
+
+protected:
+    //! Queue storage.
+    queue_storage_type queue;
+
+    //! Mutex protecting queue and flags.
+    Mutex mutex;
+
+    //! Event on which consumer can wait if it finds queue empty.
+    ManualResetEvent ev_consumer;
+
+    //! Semaphore that limits the queue length.
+    Semaphore sem;
+
+    //! State flags.
+    flags_type flags;
+
+private:
+    Queue (Queue const &);
+    Queue & operator = (Queue const &);
+};
+
+
+typedef helpers::SharedObjectPtr<Queue> QueuePtr;
+
+
+} } // namespace log4cplus { namespace thread {
+} // end namespace dcmtk
+
+
+#endif // DCMTK_LOG4CPLUS_SINGLE_THREADED
+
+#endif // DCMTK_LOG4CPLUS_HELPERS_QUEUE_H
diff --git a/oflog/include/dcmtk/oflog/helpers/sleep.h b/oflog/include/dcmtk/oflog/helpers/sleep.h
index 19f5f37..a161772 100644
--- a/oflog/include/dcmtk/oflog/helpers/sleep.h
+++ b/oflog/include/dcmtk/oflog/helpers/sleep.h
@@ -1,10 +1,11 @@
+// -*- C++ -*-
 // Module:  Log4CPLUS
 // File:    sleep.h
 // Created: 5/2003
 // Author:  Tad E. Smith
 //
 //
-// Copyright 2003-2009 Tad E. Smith
+// Copyright 2003-2010 Tad E. Smith
 //
 // Licensed under the Apache License, Version 2.0 (the "License");
 // you may not use this file except in compliance with the License.
@@ -20,19 +21,25 @@
 
 /** @file */
 
-#ifndef DCMTK__LOG4CPLUS_HELPERS_SLEEP_HEADER_
-#define DCMTK__LOG4CPLUS_HELPERS_SLEEP_HEADER_
+#ifndef DCMTK_LOG4CPLUS_HELPERS_SLEEP_HEADER_
+#define DCMTK_LOG4CPLUS_HELPERS_SLEEP_HEADER_
 
 #include "dcmtk/oflog/config.h"
 
+#if defined (DCMTK_LOG4CPLUS_HAVE_PRAGMA_ONCE)
+#pragma once
+#endif
+
 
 namespace dcmtk {
 namespace log4cplus {
     namespace helpers {
-        DCMTK_LOG4CPLUS_EXPORT void sleep(unsigned long secs);
+        DCMTK_LOG4CPLUS_EXPORT void sleep(unsigned long secs, 
+                                    unsigned long nanosecs = 0);
+        DCMTK_LOG4CPLUS_EXPORT void sleepmillis(unsigned long millis);
     } // end namespace helpers
 } // end namespace log4cplus
 } // end namespace dcmtk
 
-#endif // DCMTK__LOG4CPLUS_HELPERS_SLEEP_HEADER_
+#endif // DCMTK_LOG4CPLUS_HELPERS_SLEEP_HEADER_
 
